import { Driver } from "../../Driver";
import { TruckState } from "../TruckState";
import { InRepairState } from "./InRepairState";
import { InRunState } from "./InRunState";

function getRandomDriver (): Driver {
    const names: string[] = ['Петя', 'Вася', 'Миша', 'Саша', 'Кирилл', 'Иван', 'Матвей'];
    const surnames: string[] = ['Иванов', 'Дмитриенко', 'Петрушка', 'Царёв', 'Победнский'];
    const age: number = Math.floor(Math.random() * (100 - 25) + 25);
    const experience: number = Math.floor(Math.random() * ((age - 18) - 1) + 1); 
    const ranName = names[Math.floor(Math.random() * (names.length - 0) + 0)];
    const ranSurName = surnames[Math.floor(Math.random() * (surnames.length - 0) + 0)];

    return new Driver(ranName, ranSurName, age, experience);
};
export class InBaseState extends TruckState {
    public name: string = 'На базе';

    public changeDriver(): void {
        this.truck.driver = getRandomDriver();
        console.log('Водитель поменян успешно');
    };

    public startRun(): void {
        this.truck.changeState(new InRunState());
        console.log('Грузовик успешно выдвинулся в путь');
    };

    public startRepair(): void {
        this.truck.changeState(new InRepairState());
        console.log('Грузовик успешно отправился на починку');
    };
};

